#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include "SDL.h"
#include "SDL_image.h"

#define dispduration	5
#define AlphaStep	7
#define AlphaStep2	10


//#define TICK_INTERVAL    30

//SDL_Surface *screen; 

struct tm Today;
struct tm ExpTimeStart;
struct tm ExpTimeEnd;


//Uint32 TimeLeft(void)
//{
//    static Uint32 next_time = 0;
//    Uint32 now;
//
//    now = SDL_GetTicks();
//    if ( next_time <= now ) {
//        next_time = now+TICK_INTERVAL;
//        return(0);
//    }
//    return(next_time-now);
//}

/*
void DrawPixel(SDL_Surface *screen, int x, int y, Uint8 Red, Uint8 Green, Uint8 Blue) 
{ 
    Uint32 color = SDL_MapRGB(screen->format, Red, Green, Blue);
    switch (screen->format->BytesPerPixel) 
    { 
	case 1: // 8-bpp 
	{ 
	    Uint8 *bufp; 
	    bufp = (Uint8 *)screen->pixels + y*screen->pitch + x; 
	    *bufp = color; 
	} 
	    break; 
	case 2: // 15-bpp or 16-bpp 
	{ 
	    Uint16 *bufp; 
	    bufp = (Uint16 *)screen->pixels + y*screen->pitch/2 + x; 
	    *bufp = color; 
	} 
	    break; 
	case 3: // 24-bpp mode, usually not used 
	{ 
	    Uint8 *bufp; 
	    bufp = (Uint8 *)screen->pixels + y*screen->pitch + x * 3; 
	    if(SDL_BYTEORDER == SDL_LIL_ENDIAN) 
	    { 
		bufp[0] = color; 
		bufp[1] = color >> 8; 
		bufp[2] = color >> 16; 
	    } else { 
		bufp[2] = color; 
		bufp[1] = color >> 8; 
		bufp[0] = color >> 16; 
	    } 
	} 
	    break; 
	case 4: // 32-bpp 
	{ 
	    Uint32 *bufp; 
	    bufp = (Uint32 *)screen->pixels + y*screen->pitch/4 + x; 
	    *bufp = color; 
	} 
	    break; 
    } 
}

void DrawIMG(SDL_Surface *img, SDL_Surface* des, int x, int y)
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_BlitSurface(img, NULL, des, &dest);
}
*/

void shuffle(int *list, int n) {

	int i, j, k;

  /* initialize random seed: */
  srand ( time(NULL) );

	for (i = 0; i < n; i++)
		list[i] = i;

	for (i = 0; i < n; i++) {
		j = rand() % n;
		k = list[i];
		list[i] = list[j];
		list[j] = k;
	}

//	for (i = 0; i < n; i++)
//		list[i] = list[i] +1;

}

//-------------------------------------------------------------------------------------//
int main(int argc, char **argv)
{
    SDL_Surface *screen, *imageO, *imageM, *imageVote;
    SDL_Event event;
//    int SavedBMP=0;
    int *score;
    int *scoreanchor;
    int done=0;
    int i,j,k,k2;
    int a, b;
    int NbImages;    
    int *list;

    char *name[256], *markedfilename[256];
    char *anchorname[256], *anchornamemarked[256];
    char *outputfilename;    

    time_t now;
    time_t start;
    time_t end;

    FILE * pFile;
    FILE *fptr;


  if (argv[1] == NULL)
  {
    if ((fptr = fopen("playlist2.txt","r")) == NULL)
    { printf("problem while opening playlist2.txt\n");exit(1);}
  }
  else
  {
    if ((fptr = fopen(argv[1],"r")) == NULL)
    { printf("problem while opening argv[1]\n");exit(1);}
  }

    fscanf(fptr,"%d\n",&NbImages);
    printf("%d  images\n",NbImages);

    for (i=0;i<NbImages*2;i++)	{
		name[i] = (char *) calloc (256,sizeof(char));
	    markedfilename[i] = (char *) calloc (256,sizeof(char));
    }

	outputfilename = (char *) calloc (256,sizeof(char));

/* Anchor images */
    for (i = 0 ; i < 5 ; i++)  {
		anchorname[i] = (char *) calloc (256,sizeof(char));
	    anchornamemarked[i] = (char *) calloc (256,sizeof(char));
    }

    for (i = 0 ; i < 5 ; i++)  {
    	a = fscanf(fptr,"%s\n",anchorname[i]);
    	a = fscanf(fptr,"%s\n",anchornamemarked[i]);
    }
/* End Anchor */

    for (i = 0 ; i < NbImages ; i++)  {
	a = fscanf(fptr,"%s\n",name[i]);
//	printf("%s\n",name[i]);
	b = fscanf(fptr,"%s\n",markedfilename[i]);
//	printf("%s\n",markedfilename[i]);
    }
    fclose(fptr);

/*
    for (i = 0 ; i < 5 ; i++)  {
    	printf("anchorname[%d]: %s\n",i,anchorname[i]);
    	printf("anchornamemarked[%d]: %s\n",i,anchornamemarked[i]);
    }
    for (i = 0 ; i < NbImages ; i++)  {
    	printf("name[%d]: %s\n",i,name[i]);
    	printf("markedfilename[%d]: %s\n",i,markedfilename[i]);
    }
*/    

	time(&now);
	Today = *localtime(&now);

	sprintf(outputfilename,"output_%4.4d%2.2d%2.2d_%2.2d_%2.2d_%2.2d.log",
				Today.tm_year + 1900, Today.tm_mon + 1, Today.tm_mday, Today.tm_hour, Today.tm_min, Today.tm_sec);

    pFile = fopen (outputfilename,"w");
    fprintf(pFile,"time: %4.4d%2.2d%2.2d_%2.2d_%2.2d_%2.2d\n",
    		Today.tm_year + 1900, Today.tm_mon + 1, Today.tm_mday, Today.tm_hour, Today.tm_min, Today.tm_sec);

    /* startup SDL */
    if(SDL_Init(SDL_INIT_VIDEO)==-1)	{
	printf("SDL_Init: %s\n", SDL_GetError());
	return 1;
    }

    const SDL_VideoInfo* vidinfo = SDL_GetVideoInfo();
    
    /* open the screen for displaying the image */
    /* try to match the image size and depth    */
    screen=SDL_SetVideoMode(vidinfo->current_w, vidinfo->current_h, 24, SDL_FULLSCREEN);//SDL_ANYFORMAT );
//    screen=SDL_SetVideoMode(vidinfo->current_w, vidinfo->current_h, 24, SDL_ANYFORMAT);
    if(!screen)	{
	printf("SDL_SetVideoMode: %s\n", SDL_GetError());
	SDL_Quit();
	return 1;
    }

	/* Fill the background with Gray color (128,128,128) */
	SDL_FillRect( screen, NULL, SDL_MapRGBA(screen->format, 128, 128, 128, 255) );
	//SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 128, 128, 128));

    imageO = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, 512, 521, 24, 0,0,0,0);
    imageM = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, 512, 521, 24, 0,0,0,0);
    imageVote = SDL_CreateRGBSurface(SDL_SWSURFACE | SDL_SRCALPHA, 512, 521, 24, 0,0,0,0);


	score = (int *) calloc (NbImages-5,sizeof(int));
	scoreanchor = (int *) calloc (5,sizeof(int));

	// 'SHUFFLING' the playlist...
	list = (int *) calloc (NbImages-5,sizeof(int));

	shuffle(list, NbImages-5);

	for (i=0;i<NbImages-5;i++)	{
		printf("%d\n",list[i]);
		if (i == 0)
			fprintf(pFile,"random ordering:\n");
		fprintf(pFile,"%d\n",list[i]);
	}
	fprintf(pFile,"\nOrdered Scores:\n");
	
	// End of the 'SHUFFLING' algo.

	k2=0;

    /********      LOOP ON ALL THE PLAYLIST'S IMAGES      ********/
    for (k=0;k<NbImages;k++)
    {
    	if (k<5)	{
			imageO=IMG_Load(anchorname[k]);
		    if(!imageO)		{
			/* image failed to load */
			printf("IMG_Load1: %s for file: %s\n", IMG_GetError(),anchorname[k]);
			SDL_Quit();
			return 1;
		    }
		   imageM=IMG_Load(anchornamemarked[k]);
		    if(!imageM)		{
			/* image failed to load */
			printf("IMG_Load2: %s for file: %s\n", IMG_GetError(),anchornamemarked[k]);
			SDL_Quit();
			return 1;
		    }
    	}    		
    	else {
//	    	printf("name[k] : %s\n",name[k]);
			k2=list[k-5];
			imageO=IMG_Load(name[k2]);
		    if(!imageO)		{
			/* image failed to load */
			printf("IMG_Load1: %s for file: %s\n", IMG_GetError(),name[k2]);
			SDL_Quit();
			return 1;
		    }
//    		printf("markedfilename[k] : %s\n",markedfilename[k]);
			imageM=IMG_Load(markedfilename[k2]);
		    if(!imageM)		{
			/* image failed to load */
			printf("IMG_Load2: %s for file: %s\n", IMG_GetError(),markedfilename[k2]);
			SDL_Quit();
			return 1;
		    }
    	}

		if (imageM->w > (vidinfo->current_w/2))	{
			printf("\nThe images width are too large (%dx%d) !\nThey should be at most %d pixels width on this monitor.\n",
					imageM->w, imageM->h, vidinfo->current_w/2);
			SDL_Quit();
			exit(0);
		}

//	SDL_FillRect( screen, NULL, SDL_MapRGBA(screen->format, 128, 128, 128, 255) );
//	SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 128, 128, 128));

		/* do the initial image display */
		SDL_Rect rcDest = { ((int) (vidinfo->current_w/2) - (int)(imageM->w/2)), 
		((int) (vidinfo->current_h/2) - (int)(imageM->h/2)), imageM->w, imageM->h }; // ... , 512, 512;
		SDL_BlitSurface(imageO,0,screen,&rcDest);
		SDL_Flip(screen);

//		SDL_Rect rcDest2 = { ((int) (vidinfo->current_w/2) - (int)(imageM->w/2)), 
//		((int) (vidinfo->current_h/2) - (int)(imageM->h/2)), imageM->w, imageM->h }; // ... , 512, 512;
//		SDL_BlitSurface(imageM,0,screen,&rcDest2);
//		SDL_Flip(screen);

		/* key repeat so we don't have to keep pressing over and over... */
//		SDL_EnableKeyRepeat(1,1);
		done=0;
		if (k<5)
			scoreanchor[k]=0;
		else
			score[k2]=0;

//		time(&start);
//		ExpTimeStart = *localtime(&start);
		start = time (NULL);
//		printf("\nStart - min : %2.2d\t sec : %2.2d\n",ExpTimeStart.tm_min, ExpTimeStart.tm_sec);

		do
		{
//			time(&end);
//			ExpTimeEnd = *localtime(&end);
			end = time(NULL);
//			printf("\nEnd - min : %2.2d\t sec : %2.2d\n",ExpTimeEnd.tm_min, ExpTimeEnd.tm_sec);
//			if (ExpTimeEnd.tm_sec - ExpTimeStart.tm_sec >= 5)
			if (end - start >= dispduration)
				done = 1;
		}
		while(!done);

			/** FADE OUT **/
			int AlphaValue = 255;
			SDL_SetAlpha( imageO, SDL_SRCALPHA, AlphaValue);
			while(AlphaValue > 0)
			{
				// Decrease the alpha value by this much
				AlphaValue-=AlphaStep;

				// Clear the screen
				SDL_FillRect( imageO, NULL, SDL_MapRGBA(screen->format, 128, 128, 128, AlphaValue) );

				SDL_BlitSurface(imageO,0,screen,&rcDest);
				SDL_Flip( screen );
			}
			/** END FADE OUT **/

		SDL_BlitSurface(imageM,0,screen,&rcDest);
		SDL_Flip(screen);

//		time(&start);
//		ExpTimeStart = *localtime(&start);
		start = time (NULL);
//		printf("\nStart - min : %2.2d\t sec : %2.2d\n",ExpTimeStart.tm_min, ExpTimeStart.tm_sec);

		done = 0;
		do
		{
//			time(&end);
//			ExpTimeEnd = *localtime(&end);
			end = time(NULL);
//			printf("\nEnd - min : %2.2d\t sec : %2.2d\n",ExpTimeEnd.tm_min, ExpTimeEnd.tm_sec);
//			if (ExpTimeEnd.tm_sec - ExpTimeStart.tm_sec >= 5)
			if (end - start >= dispduration)
				done = 1;
		}
		while(!done);

			/** FADE OUT **/
			AlphaValue = 255;
			SDL_SetAlpha( imageM, SDL_SRCALPHA, AlphaValue);
			while(AlphaValue > 0)
			{
				// Decrease the alpha value by this much
				AlphaValue-=AlphaStep;

				// Clear the screen
				SDL_FillRect( imageM, NULL, SDL_MapRGBA(screen->format, 128, 128, 128, AlphaValue) );

				SDL_BlitSurface(imageM,0,screen,&rcDest);
				SDL_Flip( screen );
			}
			/** END FADE OUT **/

		imageVote=IMG_Load("images/Vote.bmp");
		SDL_BlitSurface(imageVote,0,screen,&rcDest);
		SDL_Flip( screen );

		done=0;		
		/* the event loop, redraws if needed, quits on keypress or quit event */
		while(!done && SDL_WaitEvent(&event)!=-1)
		{
		    switch(event.type)
		    {
				case SDL_KEYDOWN:
				{
				    switch(event.key.keysym.sym)
				    {
					case SDLK_ESCAPE:
						SDL_FreeSurface(screen);
						SDL_Quit();
					    exit(0);
					    break;
					case SDLK_F1:
						if (k<5)
							scoreanchor[k] = 1;
						else
						    score[k2] = 1;
					    break;
					case SDLK_F2:
						if (k<5)
							scoreanchor[k] = 2;
						else
						    score[k2] = 2;
					    break;
					case SDLK_F3:
						if (k<5)
							scoreanchor[k] = 3;
						else
						    score[k2] = 3;
					    break;
					case SDLK_F4:
						if (k<5)
							scoreanchor[k] = 4;
						else
							score[k2] = 4;
					    	break;
					case SDLK_F5:
						if (k<5)
							scoreanchor[k] = 5;
						else
						    score[k2] = 5;
					    break;
					case SDLK_y:
						if (k<5)
							scoreanchor[k] = 1;
						else
						    score[k2] = 1;
					    break;
					case SDLK_u:
						if (k<5)
							scoreanchor[k] = 2;
						else
						    score[k2] = 2;
					    break;
					case SDLK_i:
						if (k<5)
							scoreanchor[k] = 3;
						else
						    score[k2] = 3;
					    break;
					case SDLK_o:
						if (k<5)
							scoreanchor[k] = 4;
						else
							score[k2] = 4;
					    	break;
					case SDLK_p:
						if (k<5)
							scoreanchor[k] = 5;
						else
						    score[k2] = 5;
					    break;
					case SDLK_RETURN:
						if (k<5)	{
							if (scoreanchor[k] != 0)
							    done=1;
						}
						else	{
							if (score[k2] != 0)
							    done=1;
						}
				    	break;
					default:
					    break;
				    }
					if (done == 1)
					{
						/** FADE OUT **/

						int AlphaValue = 255;
						SDL_SetAlpha( imageM, SDL_SRCALPHA, AlphaValue);
						while(AlphaValue > 0)
						{
							// Decrease the alpha value by this much
							AlphaValue-=AlphaStep2;

							// Clear the screen
//							SDL_FillRect( imageM, NULL, SDL_MapRGBA(screen->format, 128, 128, 128, AlphaValue) );
							SDL_FillRect( imageM, NULL, SDL_MapRGBA(screen->format, 128, 128, 128, AlphaValue) );

							SDL_BlitSurface(imageM,0,screen,&rcDest);
							SDL_Flip( screen );
//							SDL_BlitSurface(imageM,0,screen,&rcDest2);
//							SDL_Flip( screen );
						}

						/** END FADE OUT **/

						if (k<5)
							printf("Score(anchor): %d\n",scoreanchor[k]);
						else
							printf("Score: %d\n",score[k2]);
//				    	fprintf(pFile,"%d\n",score[k2]);
					}
				break;
				}
			} // end SWITCH
		} // end WHILE
	} // end FOR(k)

	for (j=0;j<NbImages-5;j++)
		fprintf(pFile,"%d\n",score[j]);

	fprintf(pFile,"\nmarked images names:\n");
	
	for (j=0;j<NbImages-5;j++)
		fprintf(pFile,"%s\n",markedfilename[j]);

	fprintf(pFile,"\n");

	time(&now);
	Today = *localtime(&now);

//    pFile = fopen (outputfilename,"w");
    fprintf(pFile,"time: %4.4d%2.2d%2.2d_%2.2d_%2.2d_%2.2d\n",
    		Today.tm_year + 1900, Today.tm_mon + 1, Today.tm_mday, Today.tm_hour, Today.tm_min, Today.tm_sec);

	SDL_FreeSurface(imageM);
	SDL_FreeSurface(imageO);
    SDL_FreeSurface(screen);
    SDL_FreeSurface(imageVote);

    for (i=0;i<NbImages;i++)	{
	free(name[i]);
	free(markedfilename[i]);
    }
    
    for (i=0;i<5;i++)	{
	free(anchorname[i]);
	free(anchornamemarked[i]);
    }
    
	free(list);
	free(score);
	free(scoreanchor);

    /* shutdown SDL */
    SDL_Quit();
    
    fclose (pFile);
        
    return 0;
}
